import java.io.*;
import org.antlr.runtime.*;
import org.antlr.runtime.tree.*;

public class Main
{

public static org.antlr.runtime.tree.CommonTree regexpToTree(String file) throws Exception {
//	ANTLRInputStream input = new ANTLRInputStream(file)
        CharStream input = new ANTLRFileStream(file);
        // Generate a lexer for reading the formula `input'
        regexpLexer lexer = new regexpLexer(input);
        // Generate from the lexer a token stream to be fed to the parser
        CommonTokenStream tokens = new CommonTokenStream(lexer);
        // Generate the parser analyzing the token stream
        regexpParser parser = new regexpParser(tokens);
        // Finally parse the input and generate the tree
        regexpParser.r_return r = parser.r();             
        //get the AST encapsuled in r
        return (org.antlr.runtime.tree.CommonTree)r.tree;
}


    public static void walkAST( org.antlr.runtime.tree.CommonTree ast ) {
        int token = ast.getToken().getType();

        switch( token ) {
            //multi-ary connectives
            case regexpParser.OR:
                System.out.println("or");
		for(int i = 0; i < ast.getChildCount(); i++)
			walkAST((org.antlr.runtime.tree.CommonTree) ast.getChild(i));
		break;
             case regexpParser.AND:
                System.out.println("and");
		for(int i = 0; i < ast.getChildCount(); i++)
			walkAST((org.antlr.runtime.tree.CommonTree) ast.getChild(i));
		break;
             case regexpParser.CONCATENATION:
                System.out.println("concatenate");
		for(int i = 0; i < ast.getChildCount(); i++)
			walkAST((org.antlr.runtime.tree.CommonTree) ast.getChild(i));
		break;

            //unary operators
            case regexpParser.NOT:
                System.out.println("not");
            case regexpParser.STAR:
                System.out.println("star");
            case regexpParser.PLUS:
                System.out.println("plus");
            case regexpParser.MAYBE:
                System.out.println("maybe");
		
		walkAST((org.antlr.runtime.tree.CommonTree) ast.getChild(0));
		break;

	    //binary operators
            case regexpParser.POWER:
		walkAST((org.antlr.runtime.tree.CommonTree) ast.getChild(1));
                System.out.println("times");
		walkAST((org.antlr.runtime.tree.CommonTree) ast.getChild(0));
		break;

            //atoms, no children
            case regexpParser.ID:
                System.out.println(ast.getText());
                break;
            case regexpParser.INT:
                System.out.println(ast.getText());
                break;
            case regexpParser.EPSILON:
                System.out.println("epsilon");
                break;
            case regexpParser.EMPTYSET:
                System.out.println("empty_set");
                break;
            case regexpParser.ANY:
                System.out.println("SIGMA*");
                break;

            default:
                System.out.println("D'OH!");
                break;
        }
    }


public static void main(String[] args) throws Exception {
	org.antlr.runtime.tree.CommonTree ast = regexpToTree(args[0]);
	System.out.println(ast.toStringTree());
	walkAST(ast);
}

}
