grammar regexp;
options { output=AST;backtrack=true;}
tokens{
CONCATENATION;
}

init      : r EOF;
r         : r1 (OR^ r1)*;
r1        : r2 (AND^ r2)*;
r2        : r3 | (NOT^ r2);
r3        : (a=r4 -> $a) (r4+ -> ^(CONCATENATION r4+))?;
r4      :         LPAR r RPAR STAR -> ^(STAR r)
        |         LPAR r RPAR PLUS -> ^(PLUS r)
        |         LPAR r RPAR MAYBE-> ^(MAYBE r)
        |         LPAR r RPAR POWER INT -> ^(POWER r INT)
        |         ID
        |         EPSILON
        |         EMPTYSET
        |         ANY
        |         LPAR r RPAR      -> r
        ;

OR: '|';
AND: '&';
NOT: '!';
STAR: '*';
PLUS: '+';
MAYBE: '?';
POWER: '^';
EPSILON: '@';
EMPTYSET: '/';
ANY: '.';
LPAR: '(';
RPAR: ')';

ID      :         'a'..'z'|'A'..'Z'  ;
INT     :         ('0'..'9')+;
WS       :        (' '|'\n'|'\t'|'\r')+ { skip(); };